#!/bin/python3
import sys
from hamso import hamso
from hamso import dao_ham_ham_so

# lay cac tham so tu dong lenh
if (len(sys.argv)<2):
	print (" Goi ham bang lenh:")
	print ("             sys.argv[0]  a b")
	print (" Trong do a, b la hai so thuc - la khoang xac dinh nghiem can tinh")
	exit(255)
a=float(sys.argv[1])
b=float(sys.argv[2])

# mac dinh sai so la 1e-5
if (len(sys.argv)<4):
	ssyc=1e-5
else:
	ssyc=float(sys.argv[3])

# tinh ham de kiem tra khoang nghiem
(fa,ga)=hamso(a)
(fb,ga)=hamso(b)

# neu khong phai khoang nghiem thi thoat
if (fa*fb>0):
        print ("Loi: ( %f ; %f ) khong phai la khoang nghem" %(a,b))
        print ("     fa = %f, fb = %f, fa*fb>0" %(fa,fb))
        sys.exit()

# xac dinh x0 - nghiem ban dau bang phuong phap chia doi
x0=(a+b)/2

# Kiem tra dieu kien cua phuong phap lap
# khong can thiet

# khai bao ky tu de ve bang
vien_ngang='\u2500'

# Kiem tra do lon cua khoang ngiem de in bang cho phu hop
do_lon = max(abs(a),abs(b))
i=0
while (do_lon>1):
	i+=1
	do_lon /= 10
do_lon=i+8

if (do_lon < 10):
	do_lon=10

# In tieu de bang
# In tieu de bang
print (" Bang tinh ham bang phuong phap tiep tuyen\n")
do_lon+=2
print ("\u250c%s\u252c%s\u252c%s\u2510" % \
	(vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*9))
do_lon-=2
print ("\u2502",'x0'.center(do_lon, ' '),"\u2502","g(x)".center(do_lon, ' '),"\u2502",'sai so'.center(7, ' '),"\u2502")
do_lon+=2

print ("\u251c%s\u253c%s\u253c%s\u2524" % \
        (vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*9))
do_lon-=2

# Bat dau su dung phuong phap lap
(fx,x1)=hamso(x0)
ss=abs(x1-x0)
print ("\u2502",str(f"{x0:.6f}").center(do_lon, ' '),"\u2502",str(f"{x1:.6f}").center(do_lon, ' '),"\u2502", \
        str(f"{ss:.1e}").center(6,' '),"\u2502")

# Lap, moi buoc lap tinh mot buoc cua phuong phap chia doi
while (ss>ssyc):
	x0=x1
	# Tinh gia tri ham tai nghiem
	(fx,x1)=hamso(x0)
	# Xac dinh sai so hien tai
	ss=abs(x1-x0)
	# In bang ket qua
	print ("\u2502",str(f"{x0:.6f}").center(do_lon, ' '),"\u2502",str(f"{x1:.6f}").center(do_lon, ' '),"\u2502", \
                str(f"{ss:.1e}").center(6,' '),"\u2502")


# In dong cuoi cung cua bang
print ("\u2502",str(f"{x0:.6f}").center(do_lon, ' '),"\u2502",str("--").center(do_lon, ' '),"\u2502", \
                str("--").center(do_lon, ' '), "\u2502",str("--").center(do_lon, ' '),"\u2502", \
                str(f"{ss:.1e}").center(6,' '),"\u2502")


# Xac dinh nghiem khi sai so dat yeu cau
# In vien duoi cua bang
do_lon+=2
print ("\u2514%s\u2534%s\u2534%s\u2518" % \
	(vien_ngang*do_lon, vien_ngang*do_lon,  vien_ngang*9))

# In ket qua cuoi cung
print (" ")
print ("                    nghiem la: %.5f +- %.5f\n" % (x1,ss))

